unit ControlPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
    TControl_Panel = class(TForm)
    Start_Button: TButton;
    StaticText10: TStaticText;
    StaticText11: TStaticText;
    StaticText12: TStaticText;
    StaticText13: TStaticText;
    EditI1: TEdit;
    EditI2: TEdit;
    EditJ1: TEdit;
    EditJ2: TEdit;
    EditK1: TEdit;
    EditK2: TEdit;
    StaticText14: TStaticText;
    StaticText15: TStaticText;
    StaticText16: TStaticText;
    EditX1: TEdit;
    EditX2: TEdit;
    EditY1: TEdit;
    EditY2: TEdit;
    Exit_Button: TButton;
    StaticText1: TStaticText;
    EditR1: TEdit;
    EditR2: TEdit;
    EditS1: TEdit;
    EditS2: TEdit;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    EditRovX: TEdit;
    EditRovY: TEdit;
    EditRovZ: TEdit;
    StaticText5: TStaticText;
    StaticText6: TStaticText;
    StaticText7: TStaticText;
    StaticText8: TStaticText;
    procedure Plocha(Sender: TObject);
    procedure Exit(Sender: TObject);
    procedure SetDrawCaption(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Control_Panel: TControl_Panel;

implementation

uses Graph3D_2005;

{$R *.DFM}
procedure TControl_Panel.Plocha(Sender: TObject);
var Code,i     :Integer;
    fx,fy,fz,
    ErrorReport:String;
    Express_fx,
    Express_fy,
    Express_fz :TExpression;


  Procedure Setting;
  var Number:Real;
  begin
    Val(EditI1.Text,Number,Code);Draw3D.I1:=Number;
    Val(EditI2.Text,Number,Code);Draw3D.I2:=Number;
    Val(EditJ1.Text,Number,Code);Draw3D.J1:=Number;
    Val(EditJ2.Text,Number,Code);Draw3D.J2:=Number;
    Val(EditK1.Text,Number,Code);Draw3D.K1:=Number;
    Val(EditK2.Text,Number,Code);Draw3D.K2:=Number;
    Val(EditX1.Text,Number,Code);Draw3D.X1:=Number;
    Val(EditX2.Text,Number,Code);Draw3D.X2:=Number;
    Val(EditY1.Text,Number,Code);Draw3D.Y1:=Number;
    Val(EditY2.Text,Number,Code);Draw3D.Y2:=Number;
    Val(EditR1.Text,Number,Code);Draw3D.R1:=Number;
    Val(EditR2.Text,Number,Code);Draw3D.R2:=Number;
    Val(EditS1.Text,Number,Code);Draw3D.S1:=Number;
    Val(EditS2.Text,Number,Code);Draw3D.S2:=Number;
    fx:=EditRovX.Text;
    fy:=EditRovY.Text;
    fz:=EditRovZ.Text;
  end;

  begin
    Setting;
    With Draw3D do
    begin
    Visible:=True;ClearImage(255,255,255);
    Scale(x1,x2,y1,y2);
    Red:=255;Green:=0;Blue:=0;
    hr:=(r2-r1)/40;hs:=(s2-s1)/40;
    r:=r1;
    Express_fx:=PreCalc(fx,ErrorReport);
    Express_fy:=PreCalc(fy,ErrorReport);
    Express_fz:=PreCalc(fz,ErrorReport);
    Repeat
      s:=s1;i:=0;
      Repeat
         Q[i,1]:=PostCalc(Express_fx,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Q[i,2]:=PostCalc(Express_fy,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Q[i,3]:=PostCalc(Express_fz,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         s:=s+hs;i:=succ(i);
      until s>s2;
      PolyLine(Q,i,Red,Green,Blue);
      r:=r+hr;
      Image.Repaint;
      Application.ProcessMessages;
    until r>r2;
    s:=s1;
    Repeat
      r:=r1;i:=0;
      Repeat
         Q[i,1]:=PostCalc(Express_fx,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Q[i,2]:=PostCalc(Express_fy,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Q[i,3]:=PostCalc(Express_fz,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         r:=r+hr;i:=succ(i);
      until r>r2;
      PolyLine(Q,i,Red,Green,Blue);
      s:=s+hs;
      Image.Repaint;
      Application.ProcessMessages;
    until s>s2;
  end;
end;

procedure TControl_Panel.Exit(Sender: TObject);
begin
  Draw3D.Visible:=False;
  Halt;
end;
procedure TControl_Panel.SetDrawCaption(Sender: TObject);
begin
   Application.CreateForm(TDraw3D, Draw3D);
  With Draw3D do
  begin
    ClientWidth:=600;ClientHeight:=500;
    Left:=310;Top:=40;
    Caption:='Parametric Surface';
    InitImage(600,500);ClearImage(255,255,255);
    Visible:=True;
  end;

end;


end.
